﻿Procedure gauge_draw(gid, imgid, fillcolor, fillcentcol, colprog, bgprogcol, fontcol, barval.f, textval$, barmin.f, barmax.f)
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    icon_size = GadgetWidth(gid)/4
    AddPathBox(0, 0, GadgetWidth(gid), GadgetHeight(gid))
    
    AddPathCircle(GadgetWidth(gid)/2, GadgetWidth(gid)/2, GadgetWidth(gid)/3.1, 0, 360)
    VectorSourceColor(bgprogcol)
    StrokePath(GadgetWidth(gid)/10)
    rozsah.f = Abs(barmin - barmax) 
    recount.f = 360 / rozsah
    angle.f = (recount * barval) - (recount * barmin)
    AddPathCircle(GadgetWidth(gid)/2, GadgetWidth(gid)/2, GadgetWidth(gid)/3.1, 90, angle + 90)
    
    
    VectorSourceColor(colprog)
    StrokePath(GadgetWidth(gid)/12)
    FillPath()
    
    VectorSourceColor(fillcentcol)
    AddPathCircle(GadgetWidth(gid)/2, GadgetWidth(gid)/2, GadgetWidth(gid)/2.7, 0, 360)
    FillPath()
    
    MovePathCursor(0, GadgetHeight(gid)/2 + GadgetHeight(gid)/ 15)
    VectorSourceColor(fontcol)
    Color32.q = fontcol
    Color32 = Color32 & $FFFFFFFF 
    VectorFont(FontID(0), GadgetHeight(gid)/9)
    DrawVectorParagraph(Str(barval) + textval$,GadgetWidth(gid),GadgetHeight(gid)/2,#PB_VectorParagraph_Center)
    
    MovePathCursor((GadgetWidth(gid) - icon_size)/2, (GadgetHeight(gid) - icon_size)/2 - (GadgetWidth(gid)/9))
    DrawVectorImage(ImageID(imgid), Alpha(Color32), icon_size, icon_size)
    
    StopVectorDrawing()
  EndIf
EndProcedure

Procedure gauge_clear(gid)
  If StartDrawing(CanvasOutput(gid))
    Box(0, 0, GadgetWidth(gid), GadgetHeight(gid), $FFFFFF)
    StopDrawing()
  EndIf
EndProcedure



UsePNGImageDecoder()

If OpenWindow(0, 0, 0, 200, 200, "Simple Gauge", #PB_Window_SystemMenu | #PB_Window_ScreenCentered| #PB_Window3D_SizeGadget)
  AddWindowTimer(0, 123, 500)
  LoadFont(0, "Verdana", 20)
  LoadImage(0, #PB_Compiler_FilePath  + "/icons/weather.png")
  CanvasGadget(10, 0, 0, WindowWidth(0), WindowHeight(0) )
  Repeat
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      gauge_clear(10)
      gauge_draw(10,0,RGBA(255,255,255,0),RGBA(0, 0, 0, 10),RGBA(63,90,191, 200) ,RGBA(200, 200, 200, 40),RGBA(0, 0, 0, 200), Random(100,0)-50,"°C",-50,50)
    EndIf   
    If event = #PB_Event_SizeWindow
      If WindowWidth(0) < WindowHeight(0)
        CanvasGadget(10, 0, 0, WindowWidth(0), WindowWidth(0))
      Else
        CanvasGadget(10, 0, 0, WindowHeight(0), WindowHeight(0))
      EndIf
      
    EndIf
    
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

; IDE Options = PureBasic 5.72 (Linux - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; Executable = gauge